package com.ruoyi.rc.mapper;

import java.util.List;
import com.ruoyi.rc.domain.TDeptInfo;

/**
 * 装置信息Mapper接口
 * 
 * @author ruoyi
 * @date 2024-07-19
 */
public interface TDeptInfoMapper 
{
    /**
     * 查询装置信息
     * 
     * @param id 装置信息主键
     * @return 装置信息
     */
    public TDeptInfo selectTDeptInfoById(Long id);

    /**
     * 查询装置信息列表
     * 
     * @param tDeptInfo 装置信息
     * @return 装置信息集合
     */
    public List<TDeptInfo> selectTDeptInfoList(TDeptInfo tDeptInfo);

    /**
     * 新增装置信息
     * 
     * @param tDeptInfo 装置信息
     * @return 结果
     */
    public int insertTDeptInfo(TDeptInfo tDeptInfo);

    /**
     * 修改装置信息
     * 
     * @param tDeptInfo 装置信息
     * @return 结果
     */
    public int updateTDeptInfo(TDeptInfo tDeptInfo);

    /**
     * 删除装置信息
     * 
     * @param id 装置信息主键
     * @return 结果
     */
    public int deleteTDeptInfoById(Long id);

    /**
     * 批量删除装置信息
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTDeptInfoByIds(Long[] ids);
}
